package edu.westga.model.tweetAggregator;

import java.util.List;

import twitter4j.Query;
import twitter4j.QueryResult;
import twitter4j.ResponseList;
import twitter4j.Status;
import twitter4j.Tweet;
import twitter4j.Twitter;
import twitter4j.TwitterException;
import twitter4j.TwitterFactory;
import twitter4j.auth.AccessToken;

public class TweetAggregator {

	private Twitter twitter;

	public TweetAggregator() throws TwitterException {
		this.twitter = new TwitterFactory().getInstance();
		this.registerOAuth();
	}
	
	/**
	 * Searches Twitter for param searchString and returns a list of Tweet objects
	 * 
	 * @param searchString
	 * @return list of Tweet object
	 * @throws TwitterException if Twitter connectivity is not available
	 */
	public List<Tweet> doSearch(String searchString) throws TwitterException{
		QueryResult result = this.twitter.search(new Query(searchString));		
		return result.getTweets();
	}
	public List<Tweet> getTweetsFromFriends() throws TwitterException{
		return null;
	}
	
	/**
	 * @return a ResponseList of Status objects for the UWGEvents Twitter account
	 * @throws TwitterException
	 */
	public ResponseList<Status> getUWGEventsTimeLine() throws TwitterException{
		return this.twitter.getUserTimeline();
	}
	
	/**
	 * Not yet implemented, this method should return all of the tweets
	 * that are posted by friends of UWGEvents
	 * @return
	 * @throws TwitterException
	 */
	public ResponseList<Status> getFriendsTimeline() throws TwitterException{
		return this.twitter.getFriendsTimeline();
	}
	
	/**
	 * @return String the user name (this is for testing purposes 
	 * only to check we are logged in)
	 * @throws IllegalStateException
	 * @throws TwitterException
	 */
	public String getUserName() throws IllegalStateException, TwitterException{
		return this.twitter.getScreenName();
	}
	
	
	
	///////////////////////////////////////////////////////
	//////////////// PRIVATE HELPERS///////////////////////
	///////////////////////////////////////////////////////
	
	/**
	 * Logs into the UWGEvents account
	 */
	private void registerOAuth() throws TwitterException{
		String consumer_key = "KSOfIJ0DY07bqcwHCNM6g";
		String consumer_secret = "Y9jIOP1UTTPQkpFtaQAlVbdeuyQuh4SHNJYgB2Qd8DQ";
		String oauth_token = "275161562-R1A4JTdgVgQRh1aja1RkJ8LpFJ33rXiy28oIo28c";
		String oauth_token_secret = "3w93z9slTBiz5IYP52hWiTSz3r9VTtdfCYlw12KX1c";
		
		AccessToken theAccessToken = new AccessToken(oauth_token, oauth_token_secret);
		
		this.twitter.setOAuthConsumer(consumer_key, consumer_secret);
		this.twitter.setOAuthAccessToken(theAccessToken);
	}
	
	
}
