package edu.westga.HelloCalendar;

import android.app.Activity;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.ContentValues;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.text.format.DateUtils;
import android.widget.Button;
import android.widget.TextView;

public class HelloCalendar extends Activity {
	private static final long HOUR_MILLISECONDS = 3600000;
	private static final String BASE_URI_CONSTANT = "content://com.android.calendar/";
	/** Called when the activity is first created. */
	private Button myButton;
	private TextView myLabel;
	private ContentResolver cr;
	private ContentValues cv;
	private String[] calNames;
	private Uri newEvent;
	private int[] calIds;
	private Event appRelease;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
//		setContentView(R.layout.main);
//		cr = getContentResolver();
//		try {
//			appRelease = new Event("App Release", "TLC", "4/10/2011 03:00:00");
//		} catch (ParseException e) {
//			e.printStackTrace();
//		}
//		myButton = (Button) findViewById(R.id.button1);
//		myLabel = (TextView) findViewById(R.id.textView01);
//		myButton.setOnClickListener(new View.OnClickListener() {
//			public void onClick(View v) {
//				// finds all active calendars
//				findCalendar();
//				// Adds event to calendar
//				if (eventExist(appRelease)) {
//					myLabel.setText("Event already exists in current calendar");
//					finish();
//				} else {				
//					addEventToCalendar(appRelease);
//					myLabel.setText("Event has been added on to Calendar");
//					finish();
//				}
//			}
//		});

	}

	public void findCalendar() {
		String[] projection = new String[] { "_id", "name" };
		Uri calendars = Uri.parse(BASE_URI_CONSTANT + "calendars");
		Cursor managedCursor = managedQuery(calendars, projection,
				"selected=1", null, null);
		managedCursor.moveToFirst();
		calNames = new String[managedCursor.getCount()];
		calIds = new int[managedCursor.getCount()];
		for (int i = 0; i < calNames.length; i++) {
			calIds[i] = managedCursor.getInt(0);
			calNames[i] = managedCursor.getString(1);
			managedCursor.moveToNext();
		}
		managedCursor.close();
	}

	public void addEventToCalendar(Event theEvent) {
		ContentValues eventInfo = new ContentValues();
		eventInfo.put("calendar_id", calIds[0]);
		eventInfo.put("title", theEvent.getTitle());
		eventInfo.put("dtstart", theEvent.getStartDate().getTime());
		eventInfo.put("hasAlarm", 1);
		eventInfo.put("dtend", theEvent.getStartDate().getTime()
				+ HOUR_MILLISECONDS);
		eventInfo.put("eventLocation", theEvent.getLocation());
		newEvent = Uri.parse(BASE_URI_CONSTANT + "events");
		getContentResolver().insert(newEvent, eventInfo);
	}

	public void addReminder(int eventLenght) {
		String eventid = newEvent.getPathSegments().get(
				newEvent.getPathSegments().size() - 1);
		cv.put("event_id", eventid);
		cv.put("minutes", HOUR_MILLISECONDS);
		cr.insert(Uri.parse(BASE_URI_CONSTANT + "reminders"), cv);
	}

	public boolean eventExist(Event theEvent) {
		Uri.Builder builder = Uri.parse(BASE_URI_CONSTANT + "/instances/when")
				.buildUpon();
		ContentUris
				.appendId(
						builder,
						(theEvent.getStartDate().getTime() - (DateUtils.HOUR_IN_MILLIS * 24)));
		ContentUris
				.appendId(
						builder,
						(theEvent.getStartDate().getTime() + (DateUtils.HOUR_IN_MILLIS * 24)));
		Cursor eventCursor = managedQuery(builder.build(), new String[] {
				"title", "dtstart" }, null, null, null);
		eventCursor.moveToFirst();
		for (int i = 0; i < eventCursor.getCount(); i++) {
			try {
				if (eventCursor.getString(0).equals(theEvent.getTitle())
						&& eventCursor.getLong(1) == theEvent.getStartDate()
								.getTime()) {
					eventCursor.close();
					return true;
				}
			} catch (Exception ISE) {

			}
			eventCursor.moveToNext();
		}
		eventCursor.close();
		return false;
	}
}
